"use strict";function _interopDefault(e){return e&&"object"==typeof e&&"default"in e?e.default:e}var React=require("react"),React__default=_interopDefault(React),PropTypes=_interopDefault(require("prop-types")),cn=_interopDefault(require("classnames")),Paper=_interopDefault(require("@material-ui/core/Paper")),Typography=_interopDefault(require("@material-ui/core/Typography")),List=_interopDefault(require("@material-ui/core/List")),FoldIcon=_interopDefault(require("@material-ui/icons/KeyboardArrowUp")),UnfoldIcon=_interopDefault(require("@material-ui/icons/KeyboardArrowDown")),MoreVertIcon=_interopDefault(require("@material-ui/icons/MoreVert")),Collapse=_interopDefault(require("@material-ui/core/Collapse")),ListItem=_interopDefault(require("@material-ui/core/ListItem")),ListItemIcon=_interopDefault(require("@material-ui/core/ListItemIcon")),ListItemText=_interopDefault(require("@material-ui/core/ListItemText")),styles=require("@material-ui/styles"),Button=_interopDefault(require("@material-ui/core/Button")),IconButton=_interopDefault(require("@material-ui/core/IconButton")),Tooltip=_interopDefault(require("@material-ui/core/Tooltip"));function _defineProperty(e,t,r){return t in e?Object.defineProperty(e,t,{value:r,enumerable:!0,configurable:!0,writable:!0}):e[t]=r,e}function _objectSpread(e){for(var t=1;t<arguments.length;t++){var r=null!=arguments[t]?arguments[t]:{},a=Object.keys(r);"function"==typeof Object.getOwnPropertySymbols&&(a=a.concat(Object.getOwnPropertySymbols(r).filter(function(e){return Object.getOwnPropertyDescriptor(r,e).enumerable}))),a.forEach(function(t){_defineProperty(e,t,r[t])})}return e}function _objectWithoutPropertiesLoose(e,t){if(null==e)return{};var r,a,n={},o=Object.keys(e);for(a=0;a<o.length;a++)r=o[a],t.indexOf(r)>=0||(n[r]=e[r]);return n}function _objectWithoutProperties(e,t){if(null==e)return{};var r,a,n=_objectWithoutPropertiesLoose(e,t);if(Object.getOwnPropertySymbols){var o=Object.getOwnPropertySymbols(e);for(a=0;a<o.length;a++)r=o[a],t.indexOf(r)>=0||Object.prototype.propertyIsEnumerable.call(e,r)&&(n[r]=e[r])}return n}function _slicedToArray(e,t){return _arrayWithHoles(e)||_iterableToArrayLimit(e,t)||_nonIterableRest()}function _arrayWithHoles(e){if(Array.isArray(e))return e}function _iterableToArrayLimit(e,t){var r=[],a=!0,n=!1,o=void 0;try{for(var l,i=e[Symbol.iterator]();!(a=(l=i.next()).done)&&(r.push(l.value),!t||r.length!==t);a=!0);}catch(e){n=!0,o=e}finally{try{a||null==i.return||i.return()}finally{if(n)throw o}}return r}function _nonIterableRest(){throw new TypeError("Invalid attempt to destructure non-iterable instance")}var TreeContext=React__default.createContext({}),useStyles=styles.makeStyles(function(e){return{paper:{paddingTop:e.spacing(3),paddingBottom:e.spacing(3)},caption:{fontSize:16,textAlign:"center"},item:{width:"auto",height:32,paddingRight:e.spacing(2)},treeIconContainer:{minWidth:"initial"},treeIcon:{width:16,height:16,marginRight:8},treeIconButton:{color:e.palette.primary.light},treeTextButton:{color:e.palette.primary.light},treeText:{flex:"0 0 auto",paddingLeft:e.spacing(1),paddingRight:e.spacing(3)},treeTextFlex:{flex:1},button:{minWidth:"auto",minHeight:"auto",width:"auto",height:"auto",fontSize:12,lineHeight:1,padding:4},actionIcon:{width:12,height:12}}}),TreeNode=function TreeNode(e){var t=useStyles(),r=styles.useTheme(),a=React.useContext(TreeContext),n=a.foldIcon,o=a.unfoldIcon,l=a.labelKey,i=a.renderLabel,c=a.actionsAlignRight,u=a.getActionsData,s=e.data,p=e.unfoldStatus,d=e.depth,f=e.path,m=e.toggleFoldStatus,y=e.onClick,_=React.useCallback(function(e){return React__default.cloneElement(e,{className:t.treeIcon})},[t]),T=React.useCallback(function(){return i&&"function"==typeof i?i(s,p):s[l]},[i,l,s,p]),h=React.useCallback(function(e){return function(t){t.preventDefault(),t.stopPropagation(),e()}},[]),g=React.useMemo(function(){if(u&&"function"==typeof u){var e=[].concat(u(s,f,p,m)||[]);if(e&&e.length)return e.map(function(e,a){var n=e.icon,o=e.label,l=e.hint,i=e.style,u=void 0===i?{}:i,s=e.onClick,p=void 0===s?function(){}:s,d=_objectWithoutProperties(e,["icon","label","hint","style","onClick"]),m=Object.assign({marginLeft:r.spacing(2)},u),y=null;return o?y=React__default.createElement(Button,{size:"small"},n&&React__default.cloneElement(n,{className:t.actionIcon}),o):n&&(y=React__default.createElement(IconButton,null,n)),y&&(y=React__default.cloneElement(y,_objectSpread({color:"primary",className:t.button,style:m,onClick:h(p)},d)),l&&(y=React__default.createElement(Tooltip,{title:l,placement:c?"left":"right"},y))),y&&React__default.cloneElement(y,{key:"tree-node-".concat(f.join("-"),"-action-").concat(e.id||e.name||e.key||a+1)})})}return null},[u,c,s,f,p,m,r,t,h]);return React__default.createElement(ListItem,{dense:!0,button:!0,onClick:y,className:t.item,style:{marginLeft:d*r.spacing(3)}},React__default.createElement(ListItemIcon,{className:t.treeIconContainer},_(p?o:n)),React__default.createElement(ListItemText,{primary:T(),className:cn(t.treeText,_defineProperty({},t.treeTextFlex,c))}),g)};TreeNode.propTypes={data:PropTypes.object.isRequired,unfoldStatus:PropTypes.bool.isRequired,depth:PropTypes.number.isRequired,path:PropTypes.arrayOf(PropTypes.number).isRequired,toggleFoldStatus:PropTypes.func.isRequired,onClick:PropTypes.func.isRequired};var Tree=function Tree(e){var t=useStyles(),r=styles.useTheme(),a=React.useContext(TreeContext),n=a.unfoldAll,o=a.unfoldFirst,l=a.valueKey,i=a.childrenKey,c=a.pageSize,u=a.loadMoreIcon,s=a.renderLoadMoreText,p=a.requestChildrenData,d=e.data,f=e.depth,m=e.path,y=_slicedToArray(React.useState(n||0===f&&o),2),_=y[0],T=y[1],h=d[i]||[],g=Math.ceil(h.length/c),b=_slicedToArray(React.useState(0),2),R=b[0],P=b[1],I=React.useCallback(function(){T(!_)},[_,T]),C=React.useCallback(function(){var e=(R+1)*c;return h.slice(0,e).map(function(e,t){return React__default.createElement(Tree,{key:"tree-branch-".concat(e[l]),data:e,depth:f+1,path:m.concat(t)})})},[l,h,R,c,f,m]),v=React.useCallback(function(e){return React__default.cloneElement(e,{className:cn(t.treeIcon,t.treeIconButton)})},[t]),x=React.useCallback(function(){P(R+1)},[R,P]),L=React.useCallback(function(){_?I():h.length>0?I():p&&"function"==typeof p?p(d,m,I):I()},[_,I,h,p,d,m]);return React__default.createElement(React__default.Fragment,null,React__default.createElement(TreeNode,{data:d,unfoldStatus:_,depth:f,path:m,toggleFoldStatus:I,onClick:L}),React__default.createElement(Collapse,{in:_,unmountOnExit:!0},C(),_&&R+1<g&&React__default.createElement(ListItem,{dense:!0,button:!0,onClick:x,className:t.item,style:{marginLeft:(f+1)*r.spacing(3)}},React__default.createElement(ListItemIcon,{className:t.treeIconContainer},v(u)),React__default.createElement(ListItemText,{primary:s(R,c,h.length),className:cn(t.treeText,t.treeTextButton)}))))};Tree.propTypes={data:PropTypes.object.isRequired,depth:PropTypes.number.isRequired,path:PropTypes.arrayOf(PropTypes.number).isRequired};var MuiTree=function MuiTree(e){var t=useStyles(),r=e.className,a=e.title,n=e.data,o=_objectWithoutProperties(e,["className","title","data"]);return React__default.createElement(Paper,{className:cn(t.paper,r)},a&&React__default.createElement(Typography,{variant:"h6",className:t.caption},a),n&&React__default.createElement(TreeContext.Provider,{value:o},React__default.createElement(List,{dense:!0,component:"div"},React__default.createElement(Tree,{data:n,depth:0,path:[]}))))};MuiTree.defaultProps={data:{},className:"",title:"",labelKey:"label",valueKey:"value",childrenKey:"children",unfoldFirst:!1,unfoldAll:!1,pageSize:20,foldIcon:React__default.createElement(FoldIcon,null),unfoldIcon:React__default.createElement(UnfoldIcon,null),loadMoreIcon:React__default.createElement(MoreVertIcon,null),actionsAlignRight:!1,getActionsData:null,renderLabel:null,renderLoadMoreText:function renderLoadMoreText(e,t,r){return"Loaded pages: ".concat(e+1," / Page size: ").concat(t," / Total: ").concat(r,". Click here to load more...")},requestChildrenData:null},MuiTree.propTypes={data:PropTypes.object,className:PropTypes.string,title:PropTypes.oneOfType([PropTypes.string,PropTypes.node]),labelKey:PropTypes.string,valueKey:PropTypes.string,childrenKey:PropTypes.string,unfoldFirst:PropTypes.bool,unfoldAll:PropTypes.bool,pageSize:PropTypes.number,foldIcon:PropTypes.element,unfoldIcon:PropTypes.element,loadMoreIcon:PropTypes.element,actionsAlignRight:PropTypes.bool,getActionsData:PropTypes.func,renderLabel:PropTypes.func,renderLoadMoreText:PropTypes.func,requestChildrenData:PropTypes.func},module.exports=MuiTree;
